package Client.Util;

import Shared.Board;
import Shared.Constants;

import java.util.*;

import org.apache.log4j.Logger;

/**
 * Created by IntelliJ IDEA.
 * User: sehsanm
 * Date: Jan 26, 2005
 * Time: 10:28:21 PM
 * To change this template use Options | File Templates.
 */
public class BoardGraph extends Board {
    static Logger logger = Logger.getLogger("Util");
    Cell[][] nodes;
    int maxId;
    HashMap graphs = new HashMap();
//    Set enabled = new HashSet() ;

    HashSet fixeds = new HashSet();
    HashSet options = new HashSet();
    HashSet generalOptions = new HashSet();
    Graph minop = null;
    public boolean hasOption ;

    public BoardGraph(Board other) {
        this(other.getSize()) ;
        parseString(other.toString());
    }

    public BoardGraph(int n) {
        super(n);
        nodes = new Cell[n - 1][n - 1];

        for (int i = 0; i < n - 1; i++) {
            for (int j = 0; j < n - 1; j++) {
                nodes[i][j] = new Cell(this ,n, i, j);
            }
        }

        resetGraph();
        findRoots();
        printBoard();
    }

    private void resetGraph() {
        maxId = 0;
        graphs.clear();

        for (int i = 0; i < n - 1; i++)
            for (int j = 0; j < n - 1; j++)
                nodes[i][j].reset();


        for (int i = 0; i < n - 1; i++) {
            for (int j = 0; j < n - 1; j++) {
                if (i > 0)
                    nodes[i][j].neighbors.add(nodes[i - 1][j]);

                if (j > 0)
                    nodes[i][j].neighbors.add(nodes[i][j - 1]);

                if (i < n - 2)
                    nodes[i][j].neighbors.add(nodes[i + 1][j]);

                if (j < n - 2)
                    nodes[i][j].neighbors.add(nodes[i][j + 1]);
            }
        }

    }

    //TODO complete this function by asking naeem   -> ?
    public int mark(int lineno, int turn) {
        int up = super.mark(lineno, turn);

        if (up == -1)
            return -1;

        cellMark(lineno);

        return up;


    }

    public void markGraph(Graph g , int color , boolean changeTurn) {

        if (changeTurn && g.type == Graph.OPTIONTYPE) {
            int ts = g.turnScore ;
            for (Iterator iterator = g.unMarkedLines.iterator(); iterator.hasNext();) {
                Integer integer = (Integer) iterator.next();
                super.mark(integer.intValue() , color) ;
                cellMark(integer.intValue() , false);


            }
            if (color == Constants.RED)
                color = Constants.BLUE ;
            else
                color = Constants.RED ;

            int x = 0 ;
            for (Iterator iterator = g.cells.iterator(); iterator.hasNext();) {
                if(x >= g.bestScore - g.turnScore)
                    break ;
                Cell c = (Cell) iterator.next();
                cells[c.row][c.column] = color ;
                x++ ;
            }
        } else
        {
            for (Iterator iterator = g.unMarkedLines.iterator(); iterator.hasNext();) {
                Integer integer = (Integer) iterator.next();
                super.mark(integer.intValue() , color) ;
                cellMark(integer.intValue() , false);

            }
        }
        graphs.remove(new Integer(g.id)) ;
    }

    public void markMagic(Graph g , int color ) {
        if  (g.type != Graph.GENERALTYPE  || !g.hasOption())
            throw new NullPointerException("Martike ye avazi in che geraphie ?");
        for (Iterator iterator = g.magicUnmarkeds.iterator(); iterator.hasNext();) {
            Integer o = (Integer) iterator.next();
            mark(o.intValue() , color);

        }

    }


    private void cellMark(int linno) {
        cellMark(linno, true);
    }

    private void cellMark(int lineno, boolean updateGraph) {
        Cell first = null;

        if (isVertical(lineno)) {
            int ln = lineno - 1;
            int row = ln % (n - 1);
            int colLeft = ln / (n - 1) - 1;

            if (colLeft >= 0 && colLeft < n - 2) {
                nodes[row][colLeft].neighbors.remove(nodes[row][colLeft + 1]);
                nodes[row][colLeft + 1].neighbors.remove(nodes[row][colLeft]);
            }

            if (colLeft >= 0) {
                nodes[row][colLeft].unMarked--;
                first = nodes[row][colLeft];
            }

            if (colLeft < n - 2) {
                nodes[row][colLeft + 1].unMarked--;
                first = nodes[row][colLeft + 1];
            }
        } else {
            int x = lineno - (n - 1) * n - 1;
            int upRow = x / (n - 1) - 1;
            int col = x % (n - 1);

            if (upRow >= 0 && upRow < n - 2) {
                nodes[upRow][col].neighbors.remove(nodes[upRow + 1][col]);
                nodes[upRow + 1][col].neighbors.remove(nodes[upRow][col]);
            }

            if (upRow >= 0) {
                nodes[upRow][col].unMarked--;
                first = nodes[upRow][col];
            }

            if (upRow < n - 2) {
                nodes[upRow + 1][col].unMarked--;
                first = nodes[upRow + 1][col];
            }
        }

        if (updateGraph)
            updateGraphs(first, null);
    }

    //TODO this function does not check line number conditions
    public void undo(int lineno) {
        super.undo(lineno);
        cellUnmark(lineno);

    }

    public void unMarkGrpah(Graph g ) {
        for (Iterator iterator = g.unMarkedLines.iterator(); iterator.hasNext();) {
            Integer integer = (Integer) iterator.next();
            super.undo(integer.intValue()) ;
            cellUnmark(integer.intValue() , false);
        }
        graphs.put(new Integer(g.id) , g) ;
    }

    private void cellUnmark(int lineno){
        cellUnmark(lineno , true);
    }

    private void cellUnmark(int lineno , boolean updateGraph) {
        Cell first = null , second = null;

        if (isVertical(lineno)) {
            int ln = lineno - 1;
            int row = ln % (n - 1);
            int colLeft = ln / (n - 1) - 1;

            if (colLeft >= 0 && colLeft < n - 2) {
                nodes[row][colLeft].neighbors.add(nodes[row][colLeft + 1]);
                nodes[row][colLeft + 1].neighbors.add(nodes[row][colLeft]);
            }

            if (colLeft >= 0) {
                first = nodes[row][colLeft];
                nodes[row][colLeft].unMarked++;
            }

            if (colLeft < n - 2) {
                nodes[row][colLeft + 1].unMarked++;
                second = nodes[row][colLeft + 1];
            }
        } else {
            int x = lineno - (n - 1) * n - 1;
            int upRow = x / (n - 1) - 1;
            int col = x % (n - 1);

            if (upRow >= 0 && upRow < n - 2) {
                nodes[upRow][col].neighbors.add(nodes[upRow + 1][col]);
                nodes[upRow + 1][col].neighbors.add(nodes[upRow][col]);
            }

            if (upRow >= 0) {
                nodes[upRow][col].unMarked++;
                first = nodes[upRow][col];
            }

            if (upRow < n - 2) {
                nodes[upRow + 1][col].unMarked++;
                second = nodes[upRow + 1][col];
            }
        }
        if (updateGraph)
            updateGraphs(first, second);
    }

    /**
     * Finds roots of current graph. and assign id to them and maintain the Hashmap
     * for them.
     * @return  Set of Graph objects.
     */
    Set findRoots() {
        graphs.clear();
        resetFlags();
        maxId = 0;

        for (int i = 0; i < getSize() - 1; i++){
            for (int j = 0; j < getSize() - 1; j++) {
                if (!nodes[i][j].flag && nodes[i][j].unMarked > 0) {
                    Cell root = dfsMinDegree(nodes[i][j] ,null);
                    int id = maxId++;
                    graphs.put(new Integer(id), new Graph(this, root, id));
                }
            }
        }

        return graphs.keySet();
    }

    static Cell dfsMinDegree(Cell root , Cell dad) {
        if (root.flag)
            return null;

        root.flag = true;
        int min = 10;
        Cell minNeigh = null;
        if (dad != null && dad.unMarked <= 2)
            root.hasGoodNeigh = true ;
        for (Iterator iterator = root.neighbors.iterator(); iterator.hasNext();) {
            Cell cell = (Cell) iterator.next();
            if (cell.unMarked <= 2)
                root.hasGoodNeigh = true ;
            if (cell.flag)
                continue;

            cell = dfsMinDegree(cell , root);

            if (min > cell.unMarked) {
                minNeigh = cell;
                min = cell.unMarked;
            } else if (min == cell.unMarked && root.hasGoodNeigh) {
                minNeigh = cell;
                min = cell.unMarked;

            }
        }

        if (min > root.unMarked  || (min == root.unMarked && root.hasGoodNeigh)) {
            minNeigh = root;
            min = root.unMarked;
        }

        return minNeigh;

    }

    public void parseString(String data) {
        super.parseString(data);
        logger.info("Parse String **********************" + toString());
        updateCells();
        printBoard();
    }

    private void updateCells() {
        resetGraph();

        for (Iterator iterator = markedLines.iterator(); iterator.hasNext();) {
            Integer integer = (Integer) iterator.next();
            cellMark(integer.intValue(), false);
        }

        findRoots();
    }

    private void resetFlags() {
        for (int i = 0; i < n - 1; i++)
            for (int j = 0; j < n - 1; j++)
                nodes[i][j].flag = false;
    }

    private void updateGraphs(Cell cell, Cell secondCell) {
        if (secondCell == null)
            secondCell = cell;

        if (cell == null)
            cell = secondCell;

        if (cell == null)
            throw new NullPointerException("Both parameters are null");

        for (int i = 0; i < n - 1; i++) {
            for (int j = 0; j < n - 1; j++) {
                if (nodes[i][j].id == cell.id || nodes[i][j].id == secondCell.id)
                    nodes[i][j].flag = false;
                else
                    nodes[i][j].flag = true;
            }
        }

        graphs.remove(new Integer(cell.id));
        graphs.remove(new Integer(secondCell.id));

        for (int i = 0; i < n - 1; i++) {
            for (int j = 0; j < n - 1; j++) {
                if (!nodes[i][j].flag && nodes[i][j].unMarked > 0) {
                    int x = maxId + 1;
                    maxId++;
                    graphs.put(new Integer(x), new Graph(this, dfsMinDegree(nodes[i][j] , null), x));
                }

            }
        }
    }

    void printBoard() {
        logger.info("Printing BoardGraph :");

        for (Iterator iterator = graphs.values().iterator(); iterator.hasNext();) {
            logger.info(iterator.next());
        }
    }

    public Set getFreeLines() {
        Set ret = new HashSet();
        for (Iterator iterator = graphs.values().iterator(); iterator.hasNext();) {
            Graph graph = (Graph) iterator.next();

            if (graph.type == Graph.ALLSAMETYPE)
                ret.add(graph.unMarkedLines.iterator().next()) ;
            else
                ret.addAll(graph.unMarkedLines);
        }

        return ret;
    }

    public Collection getGraphs() {
        return graphs.values();
    }

    public void compute() {
        hasOption = false ;
        fixeds.clear();
        options.clear();
        generalOptions.clear();
        minop = null;

        for (Iterator iterator = graphs.values().iterator(); iterator.hasNext();) {
            Graph g = (Graph) iterator.next();

            if(g.getType() == Graph.FIXEDTYPE)
                fixeds.add(g);
            else if(g.getType() == Graph.OPTIONTYPE) {
                options.add(g);
                hasOption = true ;
            }
            else if (g.getType() == Graph.GENERALTYPE && g.hasOption()) {
                generalOptions.add(g) ;
                hasOption = true ;
            }
        }

        if(options.size() != 0) {
            Iterator iterator = options.iterator();
            minop = (Graph) iterator.next();

            while(iterator.hasNext()) {
                Graph g = (Graph) iterator.next();

                if((minop.getBestScore() - minop.getTurnScore()) > (g.getBestScore() - g.getTurnScore()))
                    minop = g;
            }

            options.remove(minop);
        }
    }

//    public boolean hasFixed() {
//        return (fixeds.size() != 0);
//    }

    public Collection getFixeds() {
        return fixeds;
    }

//    public boolean hasOption() {
//        return (options.size() != 0);
//    }

    public Collection getGeneralOptions() {
        return generalOptions;
    }

    public Collection getOptions() {
        return options;
    }

    public Graph getMinOption() {
        return minop;
    }

/*
    public void disableGraph(Graph g) {
        if (!graphs.values().contains(g))
            logger.warn("The graph does not exist");

        disabled.add(g);
    }

    public void enableGraph(Graph g) {
        if (!disabled.contains(g))
            logger.warn("The graph has not been disabled");

        disabled.remove(g);
    }
*/
}